﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NugetRestClient
{
    public class Resource
    {
        [JsonProperty(PropertyName = "@id")]
        public string @id { get; set; }
        [JsonProperty(PropertyName = "@type")]
        public string @type { get; set; }
        public string comment { get; set; }
        public string clientVersion { get; set; }
    }

    public class Context
    {
        [JsonProperty(PropertyName = "@vocab")]
        public string @vocab { get; set; }
        public string comment { get; set; }
        [JsonProperty(PropertyName = "@base")]
        public string @base { get; set; }

        public string xsd { get; set; }
        public CatalogEntry catalogEntry { get; set; }
        public Registration registration { get; set; }
        public PackageContent packageContent { get; set; }
        public Published published { get; set; }
    }

    public class ServiceIndex
    {
        public string version { get; set; }
        public List<Resource> resources { get; set; }
        [JsonProperty(PropertyName = "@context")]
        public Context @context { get; set; }
    }

    public class SearchQueryServiceResult
    {
        [JsonProperty(PropertyName = "@context")]
        public Context @context { get; set; }
        public int totalHits { get; set; }
        public DateTime lastReopen { get; set; }
        public string index { get; set; }
        public List<PackageInfo> data { get; set; }
    }

    public class Version
    {
        public string version { get; set; }
        public int downloads { get; set; }
        [JsonProperty(PropertyName = "@id")]
        public string @id { get; set; }
    }

    public class PackageInfo
    {
        [JsonProperty(PropertyName = "@id")]
        public string serviceId { get; set; }
        [JsonProperty(PropertyName = "@type")]
        public string @type { get; set; }
        public string registration { get; set; }
        public string id { get; set; }
        public string version { get; set; }
        public string description { get; set; }
        public string summary { get; set; }
        public string title { get; set; }
        public string iconUrl { get; set; }
        public string licenseUrl { get; set; }
        public string projectUrl { get; set; }
        public List<string> tags { get; set; }
        public List<string> authors { get; set; }
        public int totalDownloads { get; set; }
        public bool verified { get; set; }
        public List<Version> versions { get; set; }
    }

    public class CatalogEntry
    {
        public string @type { get; set; }
    }

    public class Registration
    {
        public string @type { get; set; }
    }

    public class PackageContent
    {
        public string @type { get; set; }
    }

    public class Published
    {
        public string @type { get; set; }
    }

    public class PackageMetadata
    {
        [JsonProperty(PropertyName = "@id")]
        public string @id { get; set; }
        [JsonProperty(PropertyName = "@type")]
        public List<string> @type { get; set; }
        public string catalogEntry { get; set; }
        public bool listed { get; set; }
        public string packageContent { get; set; }
        public DateTime published { get; set; }
        public string registration { get; set; }
        [JsonProperty(PropertyName = "@context")]
        public Context @context { get; set; }
    }
}
